// BasicRender.cpp :  α׷   մϴ.
//

#include "stdafx.h"
#include "BasicRender.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  νϽԴϴ.
TCHAR szTitle[MAX_LOADSTRING];					//  ǥ ؽƮԴϴ.
TCHAR szWindowClass[MAX_LOADSTRING];			// ⺻ â Ŭ ̸Դϴ.

//  ڵ ⿡  ִ Լ  Դϴ.
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);




//	ø̼ǿ   .
ID2D1Factory*			g_ipD2DFactory = nullptr;
ID2D1DCRenderTarget*	g_ipDCRenderTarget = nullptr;
ID2D1SolidColorBrush*	g_ipBlackBrush = nullptr;




void InitializeD2D( void )
{

	HRESULT hr = E_FAIL;

	//-----------------------------------------------------------------------
	//	D2D Factory  Ѵ.
	//-----------------------------------------------------------------------
	hr = ::D2D1CreateFactory( D2D1_FACTORY_TYPE_SINGLE_THREADED, 
							  &::g_ipD2DFactory );
	assert( hr == S_OK );


	//-----------------------------------------------------------------------
	//	ҽ Ѵ.
	//-----------------------------------------------------------------------
	assert( ::g_ipDCRenderTarget == nullptr );
	D2D1_RENDER_TARGET_PROPERTIES dxProperties = D2D1::RenderTargetProperties( D2D1_RENDER_TARGET_TYPE_DEFAULT,
																			   D2D1::PixelFormat( DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE ),
																			   0,
																			   0,
																			   D2D1_RENDER_TARGET_USAGE_NONE,
																			   D2D1_FEATURE_LEVEL_DEFAULT );
	hr = ::g_ipD2DFactory->CreateDCRenderTarget( &dxProperties, &::g_ipDCRenderTarget );
	assert( hr == S_OK );

	hr = ::g_ipDCRenderTarget->CreateSolidColorBrush( D2D1::ColorF( D2D1::ColorF::Black ),
													  &::g_ipBlackBrush );
	assert( hr == S_OK );

}




void RenderForD2D( PAINTSTRUCT& ps, RECT& rcClientArea )
{

	HRESULT hr = E_FAIL;
	hr = ::g_ipDCRenderTarget->BindDC( ps.hdc, &rcClientArea );
	::g_ipDCRenderTarget->BeginDraw();
		
		::g_ipDCRenderTarget->SetTransform( D2D1::Matrix3x2F::Identity() );
		::g_ipDCRenderTarget->Clear( D2D1::ColorF( D2D1::ColorF::White ) );
		::g_ipDCRenderTarget->DrawEllipse( D2D1::Ellipse( D2D1::Point2F( 150.0f, 150.0f ),
															100.0f,
															100.0f ),
															::g_ipBlackBrush,
															3.0f );

	hr = ::g_ipDCRenderTarget->EndDraw();
	assert( hr == S_OK );

}



void RenderForGDI( PAINTSTRUCT& ps )
{

	HGDIOBJ hOriginal = nullptr;
	hOriginal = ::SelectObject( ps.hdc, ::GetStockObject( DC_PEN ) );

	HPEN hBlackPen = ::CreatePen( PS_SOLID, 3, 0 );
	::SelectObject( ps.hdc, hBlackPen );

	::Ellipse( ps.hdc, 300, 50, 500, 250 );

	::DeleteObject( hBlackPen );
	::SelectObject( ps.hdc, hOriginal );

}


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ⿡ ڵ带 Էմϴ.
	MSG msg;
	HACCEL hAccelTable;

	//  ڿ ʱȭմϴ.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_BASICRENDER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	



	::InitializeD2D();



	//  α׷ ʱȭ մϴ.
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_BASICRENDER));



			



	// ⺻ ޽ Դϴ.
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}



	SafeRelease( &::g_ipDCRenderTarget );
	SafeRelease( &::g_ipBlackBrush );


	return (int) msg.wParam;
}



//
//  Լ: MyRegisterClass()
//
//  : â Ŭ մϴ.
//
//  :
//
//    Windows 95 ߰ 'RegisterClassEx' Լ 
//    ش ڵ尡 Win32 ý۰ ȣȯǵ
//    Ϸ 쿡  Լ մϴ.  Լ ȣؾ
//    ش  α׷ 
//    'ùٸ '     ֽϴ.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_BASICRENDER));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_BASICRENDER);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   Լ: InitInstance(HINSTANCE, int)
//
//   : νϽ ڵ ϰ  â ϴ.
//
//   :
//
//         Լ  νϽ ڵ   ϰ
//         α׷ â   ǥմϴ.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // νϽ ڵ   մϴ.

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  Լ: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :  â ޽ óմϴ.
//
//  WM_COMMAND	-  α׷ ޴ óմϴ.
//  WM_PAINT	-  â ׸ϴ.
//  WM_DESTROY	-  ޽ Խϰ ȯմϴ.
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;


	RECT rcClientArea;
	::GetClientRect( hWnd, &rcClientArea );

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// ޴   мմϴ.
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: ⿡ ׸ ڵ带 ߰մϴ.
		{


			//---------------------------------------------------------
			//	Direct2D ̿ؼ  ׸.
			//---------------------------------------------------------
			::RenderForD2D( ps, rcClientArea );	

			//---------------------------------------------------------
			//	GDI ̿ؼ  ׸.
			//---------------------------------------------------------
			::RenderForGDI( ps );

		}
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//  ȭ  ޽ óԴϴ.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
